/*
-----------------------------------------------------------------------

    Name: barbi  .h                                            21.11.93

	  Header file for all modules.

	  Updates:
	  --------

-----------------------------------------------------------------------
*/

#define NUL  0x00
#define SOH  0x01
#define STX  0x02
#define ETX  0x03
#define EOT  0x04
#define ENQ  0x05
#define ACK  0x06
#define BEL  0x07
#define BS   0x08
#define HT   0x09
#define LF   0x0a
#define VT   0x0b
#define FF   0x0c
#define CR   0x0d
#define SO   0x0e
#define SI   0x0f
#define DLE  0x10
#define DC1  0x11
#define XON  0x11
#define DC2  0x12
#define XOFF 0x13
#define DC3  0x13
#define DC4  0x14
#define NAK  0x15
#define SYN  0x16
#define ETB  0x17
#define CAN  0x18
#define EM   0x19
#define SUB  0x1a
#define ESC  0x1b
#define FS   0x1c
#define GS   0x1d
#define RS   0x1e
#define US   0x1f
#define DEL  0x7f


#define TRUE  1
#define FALSE 0


enum
{
   kNoError,
   kBarFunction,
   kBarHeight,
   kModulWidth,
   kBarSmall,
   kGapSmall,
   kBarLarge,
   kGapLarge,
   kBarString,
   kBadChar,
   kBarStringLen,
   kHeapError,
   kChecksum,
   kNotPrintableChar,
   kParameter,
   kBarAngle
};


struct sBBCode
{
	int error;
	int (*barFunction)(struct sBBCode *);
	int barSmall;
	int barLarge;
	int gapSmall;
	int gapLarge;
	int modulWidth;
       char checksum;
       char notPrintableChar;

       char *string;   
   unsigned int *bitImage;
   unsigned int bitImageLen;
       char *printObject;
   unsigned int printObjectLen;
};

typedef struct sBBCode sBBCode;

typedef int (*fCodeGen) (sBBCode *);





void          BBOpen(sBBCode *);
void          BBClose(sBBCode *);

int           BBSetBarcodeDefaults(sBBCode *, fCodeGen);
int           BBSetBarDimensions(sBBCode *, int, int);
int           BBSetGapDimensions(sBBCode *, int, int);
int           BBSetModulWidth(sBBCode *, int);
int           BBSetChecksum(sBBCode *, char);
int           BBSetNotPrintableChar(sBBCode *, char);
int           BBMakeBarcode(sBBCode *, char *);
unsigned int  BBGetBarcodeWidth(sBBCode *);
char *        BBGetHumanReadable(sBBCode *);
char *        BBGetPrintObject(sBBCode *);
unsigned int  BBGetPrintObjectLen(sBBCode *);
unsigned int *BBGetBitImage(sBBCode *);
unsigned int  BBGetBitImageLen(sBBCode *);

int           BBDownloadPostscript(sBBCode *);
int           BBDownloadHpLaserjet(sBBCode *);
int           BBDownloadEpsonLq(sBBCode *);
int           BBMakePostscript(sBBCode *, int, int);
int           BBMakeEpsonLq(sBBCode *);
int           BBMakeHpLaserjet(sBBCode *, int, int);

int           bbBcd(sBBCode *);
int           bbCodabar(sBBCode *);
int           bbCode11_1(sBBCode *);
int           bbCode11_2(sBBCode *);
int           bbCode128(sBBCode *);
int           bbCode13(sBBCode *);
int           bbCode39(sBBCode *);
int           bbCode39Extended(sBBCode *);
int           bbCode93(sBBCode *);
int           bbDatalogic2aus5(sBBCode *);
int           bbEan13(sBBCode *);
int           bbEan8(sBBCode *);
int           bbEanAdd2(sBBCode *);
int           bbEanAdd5(sBBCode *);
int           bbIndustrial2aus5(sBBCode *);
int           bbIata2aus5(sBBCode *);
int           bbInterleaved2aus5(sBBCode *);
int           bbMatrix2aus5(sBBCode *);
int           bbMsi_1(sBBCode *);
int           bbMsi_2(sBBCode *);
int           bbTelepenAlpha(sBBCode *);
int           bbTelepenNumeric(sBBCode *);
int           bbUpcA(sBBCode *);
int           bbUpcE(sBBCode *);
